<?php

App::uses('EvShopAppController', 'EvShop.Controller');
App::uses('GoogleFeedLib', 'EvShop.Lib');

class GoogleFeedController extends EvShopAppController {

	public $components = array('RequestHandler');

	public $feed = '';

	public function beforeFilter() {
		parent::beforeFilter();

		$this->Auth->allow('index');
	}

	/**
	 * main method for loading google feed
	 */
	public function index() {
		ini_set('memory_limit', '5000M');
		set_time_limit(0);

		if (Configure::read('EvShop.googleFeedUseFile') !== false) {
			if (!empty(Configure::read('EvShop.googleFeedFilepath'))) {
				if (file_exists(APP . Configure::read('EvShop.googleFeedFilepath'))) {
					$this->feed = file_get_contents(APP . Configure::read('EvShop.googleFeedFilepath'));
				}
			}
		}

		if (empty($this->feed)) {
			$this->_generateProductFeed();
		}

		$this->response->disableCache();
		$this->response->length(strlen($this->feed));
		$this->response->type('xml');
		$this->response->body($this->feed);

		// output csv
		return $this->response;
	}

/**
 * Override this to generate the feed in a different way
 */
	protected function _generateProductFeed() {
		$feedLib = new GoogleFeedLib();
		$output = $feedLib->generate();
		$this->feed = $output;
	}
}
